#include-once

Global $device = 0
Global $lastButtons = 0
Global $joy

;======================================
;	_JoyInit()
;======================================
Func _JoyInit()
;	Local $joy
	Global $JOYINFOEX_struct	= "dword[13]"

	$joy	= DllStructCreate($JOYINFOEX_struct)
	if @error Then Return 0
	DllStructSetData($joy,1,DllStructGetSize($joy),1)	;dwSize = sizeof(struct)
	DllStructSetData($joy,1,255,2)					;dwFlags = GetAll
	return $joy
EndFunc

Func _ReadBuzzKeys()
   Local $coor

   $coor	= _GetJoy($joy, $device)
   If $coor[7] > 0 and $coor[7] <> $lastButtons Then
	  $lastButtons = $coor[7]
	  Switch $coor[7]
		 case 2^0, 2^5, 2^10, 2^15 ; red
			 return 1
		 Case 2^1, 2^6, 2^11, 2^16 ; yellow
			 return 5
		 Case 2^2, 2^7, 2^12, 2^17 ; green
			 return 4
		 Case 2^3, 2^8, 2^13, 2^18 ; orange
			 return 3
		 Case 2^4, 2^9, 2^14, 2^19 ; blue
			 return 2
	  EndSwitch
   EndIf
   $lastButtons = $coor[7]
   return 0
EndFunc


;======================================
;	_GetJoy($lpJoy,$iJoy)
;	$lpJoy	Return from _JoyInit()
;	$iJoy	Joystick # 0-15
;	Return	Array containing X-Pos, Y-Pos, Z-Pos, R-Pos, U-Pos, V-Pos,POV
;			Buttons down
;
;			*POV This is a digital game pad, not analog joystick
;			65535	= Not pressed
;			0		= U
;			4500	= UR
;			9000	= R
;			Goes around clockwise increasing 4500 for each position
;======================================
Func _GetJoy($lpJoy,$iJoy)
	Local $coor,$ret

	Dim $coor[8]
	DllCall("Winmm.dll","int","joyGetPosEx","int",$iJoy,"ptr",DllStructGetPtr($lpJoy))

	if Not @error Then
		$coor[0]	= DllStructGetData($lpJoy,1,3)
		$coor[1]	= DllStructGetData($lpJoy,1,4)
		$coor[2]	= DllStructGetData($lpJoy,1,5)
		$coor[3]	= DllStructGetData($lpJoy,1,6)
		$coor[4]	= DllStructGetData($lpJoy,1,7)
		$coor[5]	= DllStructGetData($lpJoy,1,8)
		$coor[6]	= DllStructGetData($lpJoy,1,11)
		$coor[7]	= DllStructGetData($lpJoy,1,9)

;		$coor[0]	= DllStructGetData($lpJoy,1,10)
;		$coor[1]	= DllStructGetData($lpJoy,1,11)
;		$coor[2]	= DllStructGetData($lpJoy,1,12)

	EndIf

	return $coor
EndFunc

;======================================
;	_JoyClose($lpJoy)
;	Free the memory allocated for the joystick struct
;======================================
Func _JoyClose() ;($lpJoy)
	;DllStructFree($lpJoy)
EndFunc
