#include "config.au3"

#include <GUIConstantsEx.au3>
#include <ComboConstants.au3>
#include <MsgBoxConstants.au3>
#include <GuiComboBox.au3>
#include <GuiComboBoxEx.au3>
#include <GuiTab.au3>

#include <File.au3>

#include "file.au3"
#include "joystick.au3"

Global $hComboProfile
Global $hLabelButtonInfo[5]
Local $hButtonShowPosition[5]
Local $selectedProfile = Null

Func updateButtonListing()
   For $i = 0 To 4
	  GUICtrlSetData($hLabelButtonInfo[$i], $buttonName[$i] & " (" & string($buttonTarget[$i][0]) & "," & string($buttonTarget[$i][1]) & ")")
   Next
EndFunc


Func updateProfileListing(ByRef $current)
   $files = _FileListToArray($coordinatePath, '*', $FLTA_FILES)
   _GUICtrlComboBoxEx_ResetContent(GUICtrlGetHandle($hComboProfile))
   _GUICtrlComboBoxEx_ResetContent($hComboProfile)

   _GUICtrlComboBox_AddString($hComboProfile, $unsavedProfile)
   if($files[0] > 0) then
	  For $i = 1 to $files[0]
		 _GUICtrlComboBox_AddString($hComboProfile, $files[$i])
		 if $current == Null Then
			$current = $files[$i]
		 endif
	  Next
	  if $current <> Null then
		 _GUICtrlComboBox_SelectString($hComboProfile, $current)
	  endif
   endif

   ;_GUICtrlComboBoxEx_EndUpdate($hComboProfile)
EndFunc


$hGUI = GUICreate($programName, 500, 500)

$hLabelProfile = GUICtrlCreateLabel("Profiili:", 5, 5)
$hComboProfile = GUICtrlCreateCombo(Null, 50, 5, 200, 15, $CBS_DROPDOWNLIST)
updateProfileListing($selectedProfile)
if $selectedProfile <> Null Then
   loadSettings($coordinatePath & $selectedProfile)
EndIf


$y = 30
$hTab = GUICtrlCreateTab(10, $y, 480, 480)
$y += 40

GUICtrlCreateTabItem("Peliohjain")
$h = 70
$hLabelControllerInfo = GuiCtrlCreatelabel("Tmn vlilehden ollessa auki " _
		 & "peliohjaimen painallukset vlittyvt suoraan kytss olevan " _
		 & "profiilin mukaisiksi hiiren liikkeiksi klikkauksineen.", 24, $y, 390, $h)
$y += $h + 20
$x = 24
$w = 150
$hLabelController = GUICtrlCreateLabel("Kytetyn peliohjaimen numero:", $x, $y, $w)
$x += $w + 8
$hComboController = GUICtrlCreateCombo("", $x, $y, 40, 40)
GUICtrlSetData($hComboController, "0|1|2|3|4")
GUICtrlSetData($hComboController, 0)
GUISetState()

GUICtrlCreateTabItem("Muokkaus")
$y = 70
$h = 70
$hLabelModificationInfo = GuiCtrlCreateLabel("Tmn vlilehden ollessa auki " _
		 & "jokainen peliohjaimen painallus mritt klikkauksen tapahtuvan " _
		 & "jatkossa hiiren sijainnissa. Tallentamattomat muutokset hvivt " _
		 & "profiilia vaihtamalla tai ohjelman sulkemalla.", 24, $y, 390, $h)
$y += $h + 20


$h = 16
For $i = 0 to 4
   $x = 24
   $w = 100
   $hButtonShowPosition[$i] = GUICtrlCreateButton("Nyt sijainti", $x, $y, $w, $h)
   GUICtrlSetBkColor($hButtonShowPosition[$i], $buttonColor[$i])
   $x += $w + 12
   $w = 200
   $hLabelButtonInfo[$i] = GUICtrlCreateLabel("", $x, $y, $w, $h)
   $y += $h + 7
Next
updateButtonListing()

$y += 20
$h = 20
$x = 24
$w = 140
$hLabelSaveInfo = GUICtrlCreateLabel("Tallenna asetukset nimell ", $x, $y, $w, $h)
$x += $w
$w = 160
$hInputSaveName = GUICtrlCreateInput($selectedProfile, $x, $y, $w, $h)
$x += $w
$w = 60
$hButtonSave = GUICtrlCreateButton("Tallenna", $x, $y, $w, $h)

GUICtrlCreateTabItem("")

GUICtrlSetData($hTab, 1)
_GUICtrlTab_SetCurFocus($hTab, 0)

GUISetState()

#include "init_joystick.au3"

_JoyInit()

While 1
   $msg = GUIGetMsg()

   For $i = 0 To 4
	  if $msg == $hButtonShowPosition[$i] Then
		 MouseMove($buttonTarget[$i][0], $buttonTarget[$i][1])
	  EndIf
   Next

   Switch $msg
	  Case $hButtonSave
		 $profileName = GUICtrlRead($hInputSaveName, 1)
		 if $profileName <> "" Then
			if $profileName <> $unsavedProfile Then
			   saveSettings($coordinatePath & $profileName)
			   $selectedProfile = $profileName
			   updateProfileListing($selectedProfile)
			   updateButtonListing() ; shouldn't be necessary, remove in the future once everything else is working
			else
			   MsgBox($MB_OK, "Virhe", "Tiedostonimi on varattu muuhun kyttn")
			EndIf

		 Else
			MsgBox($MB_OK, "Virhe", "Anna tiedostonimi")
		 EndIf

	  case $hComboController
		 $device = int(GUICtrlRead($hComboController))
		 $lastButtons = 0

	  case $hComboProfile
		 $p = GUICtrlRead($hComboProfile, 1)
		 if $p <> $unsavedProfile then
			loadSettings($coordinatePath & $p)
			$selectedProfile = $p
			GUICtrlSetData($hInputSaveName, $p)
			updateProfileListing($selectedProfile)
			updateButtonListing()
		 endif

	  Case $GUI_EVENT_CLOSE
		 Exit
   EndSwitch

   $button = _ReadBuzzKeys()

   if $button > 0 Then
	  switch _GUICtrlTab_GetCurFocus($hTab)
	  case 0
		 MouseMove($buttonTarget[$button - 1][0], $buttonTarget[$button - 1][1])
		 MouseClick('primary')
	  case 1
		 $mousePos = MouseGetPos()
		 $buttonTarget[$button - 1][0] = $mousePos[0]
		 $buttonTarget[$button - 1][1] = $mousePos[1]
		 updateButtonListing()
		 $selectedProfile = $unsavedProfile
		 _GUICtrlComboBox_SelectString($hComboProfile, $selectedProfile)
	  EndSwitch
   EndIf
WEnd

_JoyClose()
